## koji 1.10.0

=== Makefile ===
NAME=koji
SPECFILE = $(firstword $(wildcard *.spec))
SUBDIRS = hub builder koji cli docs util www plugins vm

ifdef DIST
DIST_DEFINES := --define "dist $(DIST)"
endif

ifndef VERSION
VERSION := $(shell rpm $(RPM_DEFINES) $(DIST_DEFINES) -q --qf "%{VERSION}\n" --specfile $(SPECFILE)| head -1)
endif
# the release of the package
ifndef RELEASE
RELEASE := $(shell rpm $(RPM_DEFINES) $(DIST_DEFINES) -q --qf "%{RELEASE}\n" --specfile $(SPECFILE)| head -1)
endif

ifndef WORKDIR
WORKDIR := $(shell pwd)
endif
## Override RPM_WITH_DIRS to avoid the usage of these variables.
ifndef SRCRPMDIR
SRCRPMDIR = $(WORKDIR)
endif
ifndef BUILDDIR
BUILDDIR = $(WORKDIR)
endif
ifndef RPMDIR
RPMDIR = $(WORKDIR)
endif
## SOURCEDIR is special; it has to match the CVS checkout directory,-
## because the CVS checkout directory contains the patch files. So it basically-
## can't be overridden without breaking things. But we leave it a variable
## for consistency, and in hopes of convincing it to work sometime.
ifndef SOURCEDIR
SOURCEDIR := $(shell pwd)
endif


# RPM with all the overrides in place;
ifndef RPM
RPM := $(shell if test -f /usr/bin/rpmbuild ; then echo rpmbuild ; else echo rpm ; fi)
endif
ifndef RPM_WITH_DIRS
RPM_WITH_DIRS = $(RPM) --define "_sourcedir $(SOURCEDIR)" \
		    --define "_builddir $(BUILDDIR)" \
		    --define "_srcrpmdir $(SRCRPMDIR)" \
		    --define "_rpmdir $(RPMDIR)"
endif

# tag to export, defaulting to current tag in the spec file
ifndef TAG
TAG=$(NAME)-$(VERSION)-$(RELEASE)
endif

_default:
	@echo "read the makefile"

clean:
	rm -f *.o *.so *.pyc *~ koji*.bz2 koji*.src.rpm
	rm -rf koji-$(VERSION)
	for d in $(SUBDIRS); do make -s -C $$d clean; done

git-clean:
	@git clean -d -q -x

subdirs:
	for d in $(SUBDIRS); do make -C $$d; [ $$? = 0 ] || exit 1; done

test-tarball:
	@rm -rf .koji-$(VERSION)
	@mkdir .koji-$(VERSION)
	@cp -al [A-Za-z]* .koji-$(VERSION)
	@mv .koji-$(VERSION) koji-$(VERSION)
	tar --bzip2 --exclude '*.tar.bz2' --exclude '*.rpm' --exclude '.#*' \
	    -cpf koji-$(VERSION).tar.bz2 koji-$(VERSION)
	@rm -rf koji-$(VERSION)

tarball: clean
	@git archive --format=tar --prefix=$(NAME)-$(VERSION)/ HEAD |bzip2 > $(NAME)-$(VERSION).tar.bz2

sources: tarball

srpm: tarball
	$(RPM_WITH_DIRS) $(DIST_DEFINES) -bs $(SPECFILE)

rpm: tarball
	$(RPM_WITH_DIRS) $(DIST_DEFINES) -bb $(SPECFILE)

test-rpm: tarball
	$(RPM_WITH_DIRS) $(DIST_DEFINES) --define "testbuild 1" -bb $(SPECFILE)

tag::
	git tag -a $(TAG)
	@echo "Tagged with: $(TAG)"
	@echo

force-tag::
	git tag -f -a $(TAG)
	@echo "Tagged with: $(TAG)"
	@echo

# If and only if "make build" fails, use "make force-tag" to 
# re-tag the version.
#force-tag: $(SPECFILE)
#	@$(MAKE) tag TAG_OPTS="-F $(TAG_OPTS)"

DESTDIR ?= /
TYPE = systemd
install:
	@if [ "$(DESTDIR)" = "" ]; then \
		echo " "; \
		echo "ERROR: A destdir is required"; \
		exit 1; \
	fi

	mkdir -p $(DESTDIR)

	for d in $(SUBDIRS); do make DESTDIR=`cd $(DESTDIR); pwd` \
		-C $$d install TYPE=$(TYPE); [ $$? = 0 ] || exit 1; done

=== builder/Makefile ===
BINFILES = kojid
LIBEXECFILES = mergerepos
SYSTEMDSYSTEMUNITDIR = $(shell pkg-config systemd --variable=systemdsystemunitdir)
TYPE = systemd

_default:
	@echo "nothing to make.  try make install"

clean:
	rm -f *.o *.so *.pyc *~


_install:
	@if [ "$(DESTDIR)" = "" ]; then \
		echo " "; \
		echo "ERROR: A destdir is required"; \
		exit 1; \
	fi

	mkdir -p $(DESTDIR)/usr/sbin
	install -p -m 755 $(BINFILES) $(DESTDIR)/usr/sbin

	mkdir -p $(DESTDIR)/usr/libexec/kojid
	install -p -m 755 $(LIBEXECFILES) $(DESTDIR)/usr/libexec/kojid

	mkdir -p $(DESTDIR)/etc/mock/koji

	mkdir -p $(DESTDIR)/etc/kojid
	install -p -m 644 kojid.conf $(DESTDIR)/etc/kojid/kojid.conf

install-systemd: _install
	mkdir -p $(DESTDIR)$(SYSTEMDSYSTEMUNITDIR)
	install -p -m 644 kojid.service $(DESTDIR)$(SYSTEMDSYSTEMUNITDIR)

install-sysv: _install
	mkdir -p $(DESTDIR)/etc/rc.d/init.d
	install -p -m 755 kojid.init $(DESTDIR)/etc/rc.d/init.d/kojid

	mkdir -p $(DESTDIR)/etc/sysconfig
	install -p -m 644 kojid.sysconfig $(DESTDIR)/etc/sysconfig/kojid

install: install-$(TYPE)

=== cli/Makefile ===
FILES = koji

_default:
	@echo "nothing to make.  try make install"

clean:
	rm -f *.o *.so *.pyc *~

install:
	@if [ "$(DESTDIR)" = "" ]; then \
		echo " "; \
		echo "ERROR: A destdir is required"; \
		exit 1; \
	fi

	mkdir -p $(DESTDIR)/usr/bin
	install -p -m 755 $(FILES) $(DESTDIR)/usr/bin
	install -p -m 644 koji.conf $(DESTDIR)/etc/koji.conf
	mkdir -p $(DESTDIR)/etc/koji.conf.d

=== docs/Makefile ===
install:

clean:
	rm -f *.o *.so *.pyc *~

=== hub/Makefile ===
PYTHON=python
PACKAGE = $(shell basename `pwd`)
LIBEXECFILES = rpmdiff
PYFILES = $(wildcard *.py)
PYVER := $(shell $(PYTHON) -c 'import sys; print "%.3s" %(sys.version)')
PYSYSDIR := $(shell $(PYTHON) -c 'import sys; print sys.prefix')
PYLIBDIR = $(PYSYSDIR)/lib/python$(PYVER)
PKGDIR = $(PYLIBDIR)/site-packages/$(PACKAGE)

SERVERDIR = /usr/share/koji-hub
PYFILES = $(wildcard *.py)

_default:
	@echo "nothing to make.  try make install"

clean:
	rm -f *.o *.so *.pyc *~

install:
	@if [ "$(DESTDIR)" = "" ]; then \
		echo " "; \
		echo "ERROR: A destdir is required"; \
		exit 1; \
	fi

	mkdir -p $(DESTDIR)/usr/libexec/koji-hub
	install -p -m 755 $(LIBEXECFILES) $(DESTDIR)/usr/libexec/koji-hub

	mkdir -p $(DESTDIR)/etc/httpd/conf.d
	install -p -m 644 httpd.conf $(DESTDIR)/etc/httpd/conf.d/kojihub.conf

	mkdir -p $(DESTDIR)/etc/koji-hub
	install -p -m 644 hub.conf $(DESTDIR)/etc/koji-hub/hub.conf
	mkdir -p $(DESTDIR)/etc/koji-hub/hub.conf.d

	mkdir -p $(DESTDIR)/$(SERVERDIR)
	for p in $(PYFILES) ; do \
		install -p -m 644 $$p $(DESTDIR)/$(SERVERDIR)/$$p; \
	done
	$(PYTHON) -c "import compileall; compileall.compile_dir('$(DESTDIR)/$(SERVERDIR)', 1, '$(PYDIR)', 1)"

=== koji/Makefile ===
SUBDIRS = ssl

PYTHON=python
PACKAGE = $(shell basename `pwd`)
PYFILES = $(wildcard *.py)
PYSCRIPTS = context.py
PYVER := $(shell $(PYTHON) -c 'import sys; print "%.3s" %(sys.version)')
PYSYSDIR := $(shell $(PYTHON) -c 'import sys; print sys.prefix')
PYLIBDIR = $(PYSYSDIR)/lib/python$(PYVER)
PKGDIR = $(PYLIBDIR)/site-packages/$(PACKAGE)

_default:
	@echo "nothing to make.  try make install"

clean:
	rm -f *.o *.so *.pyc *~
	for d in $(SUBDIRS); do make -s -C $$d clean; done

install:
	mkdir -p $(DESTDIR)/$(PKGDIR)
	for p in $(PYFILES) ; do \
		install -p -m 644 $$p $(DESTDIR)/$(PKGDIR)/$$p; \
	done
	for p in $(PYSCRIPTS) ; do \
		chmod 0755 $(DESTDIR)/$(PKGDIR)/$$p; \
	done
	$(PYTHON) -c "import compileall; compileall.compile_dir('$(DESTDIR)/$(PKGDIR)', 1, '$(PYDIR)', 1)"

	for d in $(SUBDIRS); do make DESTDIR=$(DESTDIR)/$(PKGDIR)/$$d \
		-C $$d install; [ $$? = 0 ] || exit 1; done

=== plugins/Makefile ===
PYTHON=python
PLUGINDIR = /usr/lib/koji-hub-plugins
FILES = $(wildcard *.py)
CONFDIR = /etc/koji-hub/plugins
CONFFILES = $(wildcard *.conf)

_default:
	@echo "nothing to make.  try make install"

clean:
	rm -f *.o *.so *.pyc *.pyo *~

install:
	@if [ "$(DESTDIR)" = "" ]; then \
		echo " "; \
		echo "ERROR: A destdir is required"; \
		exit 1; \
	fi

	mkdir -p $(DESTDIR)/$(PLUGINDIR)
	install -p -m 644 $(FILES) $(DESTDIR)/$(PLUGINDIR)
	$(PYTHON) -c "import compileall; compileall.compile_dir('$(DESTDIR)/$(PLUGINDIR)', 1, '$(PLUGINDIR)', 1)"
	mkdir -p $(DESTDIR)/$(CONFDIR)
	install -p -m 644 $(CONFFILES) $(DESTDIR)/$(CONFDIR)

=== util/Makefile ===
BINFILES = kojira koji-gc koji-shadow
SYSTEMDSYSTEMUNITDIR = $(shell pkg-config systemd --variable=systemdsystemunitdir)
TYPE = systemd

_default:
	@echo "nothing to make. try make install"

clean:
	rm -f *.o *.so *.pyc *~

_install:
	@if [ "$(DESTDIR)" = "" ]; then \
		echo " "; \
		echo "ERROR: A destdir is required"; \
		exit 1; \
	fi
	mkdir -p $(DESTDIR)/usr/sbin
	install -p -m 755 $(BINFILES) $(DESTDIR)/usr/sbin

	mkdir -p $(DESTDIR)/etc/kojira
	install -p -m 644 kojira.conf $(DESTDIR)/etc/kojira/kojira.conf

	mkdir -p $(DESTDIR)/etc/koji-gc
	install -p -m 644 koji-gc.conf $(DESTDIR)/etc/koji-gc/koji-gc.conf

	mkdir -p $(DESTDIR)/etc/koji-shadow
	install -p -m 644 koji-shadow.conf $(DESTDIR)/etc/koji-shadow/koji-shadow.conf

install-systemd: _install
	mkdir -p $(DESTDIR)$(SYSTEMDSYSTEMUNITDIR)
	install -p -m 644 kojira.service $(DESTDIR)$(SYSTEMDSYSTEMUNITDIR)

install-sysv: _install
	mkdir -p $(DESTDIR)/etc/rc.d/init.d
	install -p -m 755 kojira.init $(DESTDIR)/etc/rc.d/init.d/kojira

	mkdir -p $(DESTDIR)/etc/sysconfig
	install -p -m 644 kojira.sysconfig $(DESTDIR)/etc/sysconfig/kojira

install: install-$(TYPE)

=== vm/Makefile ===
BINFILES = kojivmd
SHAREFILES = kojikamid
SYSTEMDSYSTEMUNITDIR = $(shell pkg-config systemd --variable=systemdsystemunitdir)
TYPE = systemd

_default:
	@echo "nothing to make.  try make install"

clean:
	rm -f *.o *.so *.pyc *~ kojikamid

kojikamid: kojikamid.py
	bash fix_kojikamid.sh >kojikamid

_install: kojikamid
	@if [ "$(DESTDIR)" = "" ]; then \
		echo " "; \
		echo "ERROR: A destdir is required"; \
		exit 1; \
	fi

	mkdir -p $(DESTDIR)/usr/sbin
	install -p -m 755 $(BINFILES) $(DESTDIR)/usr/sbin

	mkdir -p $(DESTDIR)/usr/share/kojivmd
	install -p -m 644 $(SHAREFILES) $(DESTDIR)/usr/share/kojivmd

	mkdir -p $(DESTDIR)/etc/kojivmd
	install -p -m 644 kojivmd.conf $(DESTDIR)/etc/kojivmd/kojivmd.conf

install-systemd: _install
	mkdir -p $(DESTDIR)$(SYSTEMDSYSTEMUNITDIR)
	install -p -m 644 kojivmd.service $(DESTDIR)$(SYSTEMDSYSTEMUNITDIR)

install-sysv: _install
	mkdir -p $(DESTDIR)/etc/rc.d/init.d
	install -p -m 755 kojivmd.init $(DESTDIR)/etc/rc.d/init.d/kojivmd

	mkdir -p $(DESTDIR)/etc/sysconfig
	install -p -m 644 kojivmd.sysconfig $(DESTDIR)/etc/sysconfig/kojivmd

install: install-$(TYPE)

=== www/Makefile ===
SUBDIRS = kojiweb conf lib static

_default:
	@echo "nothing to make.  try make install"

clean:
	rm -f *.o *.so *.pyc *~
	for d in $(SUBDIRS); do make -s -C $$d clean; done

install:
	@if [ "$(DESTDIR)" = "" ]; then \
		echo " "; \
		echo "ERROR: A destdir is required"; \
		exit 1; \
	fi

	mkdir -p $(DESTDIR)/usr/share/koji-web

	for d in $(SUBDIRS); do make DESTDIR=$(DESTDIR) \
		-C $$d install; [ $$? = 0 ] || exit 1; done

=== koji/ssl/Makefile ===
FILES = $(wildcard *.py)

PYTHON=python

_default:
	@echo "nothing to make.  try make install"

clean:
	rm -f *.o *.so *.pyc *~

install:
	@if [ "$(DESTDIR)" = "" ]; then \
		echo " "; \
		echo "ERROR: A destdir is required"; \
		exit 1; \
	fi

	mkdir -p $(DESTDIR)
	install -p -m 644 $(FILES) $(DESTDIR)

	$(PYTHON) -c "import compileall; compileall.compile_dir('$(DESTDIR)', 1, '$(PYDIR)', 1)"

=== www/conf/Makefile ===
_default:
	@echo "nothing to make.  try make install"

clean:
	rm -f *.o *.so *.pyc *~
	for d in $(SUBDIRS); do make -s -C $$d clean; done

install:
	@if [ "$(DESTDIR)" = "" ]; then \
		echo " "; \
		echo "ERROR: A destdir is required"; \
		exit 1; \
	fi

	mkdir -p $(DESTDIR)/etc/httpd/conf.d
	install -p -m 644 kojiweb.conf $(DESTDIR)/etc/httpd/conf.d/kojiweb.conf

	mkdir -p $(DESTDIR)/etc/kojiweb
	install -p -m 644 web.conf $(DESTDIR)/etc/kojiweb/web.conf
	mkdir -p $(DESTDIR)/etc/kojiweb/web.conf.d

=== debian/changelog ===
koji (1.10.0-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * Initial release. (Closes: #806953)

 -- Ximin Luo <infinity0@debian.org>  Fri, 04 Dec 2015 11:20:57 +0100

=== debian/control ===
Source: koji
Maintainer: Reproducible Builds Maintainers <reproducible-builds@lists.alioth.debian.org>
Uploaders: Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>,
 Ximin Luo <infinity0@debian.org>
Section: devel
Priority: extra
Standards-Version: 3.9.6
Build-Depends:
 debhelper (>= 9.0),
 dh-python,
 dh-systemd,
 createrepo,
 help2man,
 pkg-config,
 python-all,
 python-cheetah,
 python-libvirt,
 python-libxml2,
 python-openssl,
 python-qpid,
 python-rpm,
 python-simplejson,
 python-urlgrabber,
 rpm,
 systemd,
 yum,
Homepage: https://fedorahosted.org/koji/
Vcs-Git: https://anonscm.debian.org/git/reproducible/koji.git
Vcs-Browser: https://anonscm.debian.org/cgit/reproducible/koji.git

Package: koji-common
Architecture: all
Section: python
Depends: ${misc:Depends}, ${python:Depends},
#python-krbV,
 python-openssl,
 python-rpm,
Description: RPM-based build system - common library
 The Fedora Project uses Koji for their build system, as do several other
 projects.
 .
 Koji's goal is to provide a flexible, secure, and reproducible way to build
 software.
 .
 Key features:
 .
  -  New buildroot for each build
  -  Robust XML-RPC APIs for easy integration with other tools
  -  Web interface with SSL and Kerberos authentication
  -  Thin, portable command line client
  -  Users can create local buildroots
  -  Buildroot contents are tracked in the database
  -  Versioned data
 .
 This package contains the common Python library used by other components.

Package: koji-client
Architecture: all
Depends: python, ${misc:Depends}, ${python:Depends}, koji-common (= ${binary:Version}),
 python-urlgrabber,
 yum,
Description: RPM-based build system - client
 The Fedora Project uses Koji for their build system, as do several other
 projects.
 .
 Koji's goal is to provide a flexible, secure, and reproducible way to build
 software.
 .
 Key features:
 .
  -  New buildroot for each build
  -  Robust XML-RPC APIs for easy integration with other tools
  -  Web interface with SSL and Kerberos authentication
  -  Thin, portable command line client
  -  Users can create local buildroots
  -  Buildroot contents are tracked in the database
  -  Versioned data
 .
 This package contains the koji client that queries remote build systems as
 well as perform actions such as adding users and initiating build requests.

Package: koji-servers
Architecture: all
Depends: python, ${misc:Depends}, ${python:Depends}, koji-common (= ${binary:Version}),
 createrepo,
 python-cheetah,
#python-krbV,
 python-libvirt,
 python-libxml2,
 python-qpid,
 python-rpm,
 python-simplejson,
 python-urlgrabber,
 yum,
Recommends: httpd
Suggests: systemd
Description: RPM-based build system - server components
 The Fedora Project uses Koji for their build system, as do several other
 projects.
 .
 Koji's goal is to provide a flexible, secure, and reproducible way to build
 software.
 .
 Key features:
 .
  -  New buildroot for each build
  -  Robust XML-RPC APIs for easy integration with other tools
  -  Web interface with SSL and Kerberos authentication
  -  Thin, portable command line client
  -  Users can create local buildroots
  -  Buildroot contents are tracked in the database
  -  Versioned data
 .
 This package contains the server components of the koji build system.
 .
  - koji-hub, the center of all Koji operations. It is an XML-RPC server
    running under mod_wsgi in Apache.
  - kojid is the build daemon that runs on each of the build machines.
  - koji-web is a set of scripts that run in mod_wsgi and use the Cheetah
    templating engine to provide a web interface to Koji.
  - kojira is a daemon that keeps the build root repodata updated.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

H2M = PYTHONPATH=. help2man --no-info --version-string=$(DEB_VERSION_UPSTREAM)

%:
	dh $@ --with python2

override_dh_auto_build:
	dh_auto_build
	$(H2M) -n "Koji build client" ./cli/koji > debian/koji.1
	$(H2M) -n "Koji build daemon" ./builder/kojid > debian/kojid.1
	$(H2M) -n "Garbage collection tool for Koji" ./util/koji-gc > debian/koji-gc.1
	$(H2M) -n "Shadow builds between koji instances" ./util/koji-shadow > debian/koji-shadow.1
	$(H2M) -n "Koji repository administrator" ./util/kojira > debian/kojira.1
	$(H2M) -n "Koji virtual machine management daemon" ./vm/kojivmd > debian/kojivmd.1

override_dh_auto_clean:
	rm -f debian/koji*.1
	dh_auto_clean

override_dh_install:
	dh_install --fail-missing

override_dh_python2:
	dh_python2 -p koji-common
	dh_python2 -p koji-client
	dh_python2 -p koji-servers /usr/lib/koji-hub-plugins/
	dh_python2 -p koji-servers /usr/share/koji-hub/
	dh_python2 -p koji-servers /usr/share/koji-web/
	dh_python2 -p koji-servers /usr/share/koji-web/lib/kojiweb/

=== debian/watch ===
version=3
https://fedorahosted.org/released/koji/koji-(.+).tar.bz2

## koji 1.16.0

=== koji/Makefile ===
--- 
+++ 
@@ -1,11 +1,17 @@
-SUBDIRS = ssl
-
 PYTHON=python
 PACKAGE = $(shell basename `pwd`)
-PYFILES = $(wildcard *.py)
-PYSCRIPTS = context.py
-PYVER := $(shell $(PYTHON) -c 'import sys; print "%.3s" %(sys.version)')
-PYSYSDIR := $(shell $(PYTHON) -c 'import sys; print sys.prefix')
+ifeq ($(PYTHON), python3)
+    # for python3 we fully support only basic library + CLI
+    PYFILES = __init__.py util.py plugin.py xmlrpcplus.py
+    PYSCRIPTS =
+    SUBDIRS =
+else
+    PYFILES = $(wildcard *.py)
+    PYSCRIPTS = context.py
+    SUBDIRS =
+endif
+PYVER := $(shell $(PYTHON) -c 'import sys; print("%.3s" % (sys.version))')
+PYSYSDIR := $(shell $(PYTHON) -c 'import sys; print(sys.prefix)')
 PYLIBDIR = $(PYSYSDIR)/lib/python$(PYVER)
 PKGDIR = $(PYLIBDIR)/site-packages/$(PACKAGE)

=== plugins/Makefile ===
PYTHON=python
PYVER := $(shell $(PYTHON) -c 'import sys; print("%.3s" %(sys.version))')
PYSYSDIR := $(shell $(PYTHON) -c 'import sys; print(sys.prefix)')
PYLIBDIR = $(PYSYSDIR)/lib/python$(PYVER)
PKGDIR = $(PYLIBDIR)/site-packages

CLIPLUGINDIR = $(PKGDIR)/koji_cli_plugins
HUBPLUGINDIR = /usr/lib/koji-hub-plugins
BUILDERPLUGINDIR = /usr/lib/koji-builder-plugins
CLIFILES = $(wildcard cli/*.py)
HUBFILES = $(wildcard hub/*.py)
BUILDERFILES = $(wildcard builder/*.py)
CLICONFDIR = /etc/koji/plugins
HUBCONFDIR = /etc/koji-hub/plugins
BUILDERCONFDIR = /etc/kojid/plugins
CLICONFFILES = $(wildcard cli/*.conf)
HUBCONFFILES = $(wildcard hub/*.conf)
BUILDERCONFFILES = $(wildcard builder/*.conf)

_default:
	@echo "nothing to make.  try make install"

clean:
	rm -f *.o *.so *.pyc *.pyo *~

install:
	@if [ "$(DESTDIR)" = "" ]; then \
		echo " "; \
		echo "ERROR: A destdir is required"; \
		exit 1; \
	fi
	if [ "$(PYTHON)" == "python" ] ; then \
		mkdir -p $(DESTDIR)/$(HUBPLUGINDIR); \
		mkdir -p $(DESTDIR)/$(BUILDERPLUGINDIR); \
		install -p -m 644 $(HUBFILES) $(DESTDIR)/$(HUBPLUGINDIR); \
		install -p -m 644 $(BUILDERFILES) $(DESTDIR)/$(BUILDERPLUGINDIR); \
		$(PYTHON) -c "import compileall; compileall.compile_dir('$(DESTDIR)/$(HUBPLUGINDIR)', 1, '$(HUBPLUGINDIR)', 1)"; \
		$(PYTHON) -c "import compileall; compileall.compile_dir('$(DESTDIR)/$(BUILDERPLUGINDIR)', 1, '$(BUILDERPLUGINDIR)', 1)"; \
		mkdir -p $(DESTDIR)/$(HUBCONFDIR); \
		mkdir -p $(DESTDIR)/$(BUILDERCONFDIR); \
		install -p -m 644 $(HUBCONFFILES) $(DESTDIR)/$(HUBCONFDIR); \
		install -p -m 644 $(BUILDERCONFFILES) $(DESTDIR)/$(BUILDERCONFDIR); \
	fi

	mkdir -p $(DESTDIR)/$(CLIPLUGINDIR)
	install -p -m 644 $(CLIFILES) $(DESTDIR)/$(CLIPLUGINDIR)
	$(PYTHON) -c "import compileall; compileall.compile_dir('$(DESTDIR)/$(CLIPLUGINDIR)', 1, '$(CLIPLUGINDIR)', 1)"
	mkdir -p $(DESTDIR)/$(CLICONFDIR)
        ifneq "$(CLICONFFILES)" ""
	install -p -m 644 $(CLICONFFILES) $(DESTDIR)/$(CLICONFDIR)
        endif

=== debian/changelog ===
koji (1.16.0-2) unstable; urgency=medium

  * Install a conf file for fedora's current main koji hub.

 -- Ximin Luo <infinity0@debian.org>  Sun, 08 Jul 2018 12:37:16 -0700

koji (1.16.0-1) unstable; urgency=medium

  * New upstream release. (Closes: #877921, #877886, #877887)

 -- Ximin Luo <infinity0@debian.org>  Sun, 08 Jul 2018 12:06:37 -0700

=== debian/control ===
--- 
+++ 
@@ -3,36 +3,43 @@
 Uploaders: Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>,
  Ximin Luo <infinity0@debian.org>
 Section: devel
-Priority: extra
-Standards-Version: 3.9.6
+Priority: optional
+Standards-Version: 4.1.5
 Build-Depends:
- debhelper (>= 9.0),
+ debhelper (>= 9.20160709),
  dh-python,
- dh-systemd,
  createrepo,
  help2man,
  pkg-config,
  python-all,
  python-cheetah,
+ python-dateutil,
  python-libvirt,
  python-libxml2,
  python-openssl,
  python-qpid,
+ python-requests,
+ python-requests-kerberos,
  python-rpm,
  python-simplejson,
- python-urlgrabber,
+ python-six,
+ python-nose <!nocheck>,
+ python-mock <!nocheck>,
+ python-qpid-proton <!nocheck>,
+ python-krbv <!nocheck>,
+ python-psycopg2 <!nocheck>,
  rpm,
  systemd,
  yum,
-Homepage: https://fedorahosted.org/koji/
-Vcs-Git: https://anonscm.debian.org/git/reproducible/koji.git
-Vcs-Browser: https://anonscm.debian.org/cgit/reproducible/koji.git
+Homepage: https://pagure.io/koji
+Vcs-Git: https://salsa.debian.org/reproducible-builds/koji.git
+Vcs-Browser: https://salsa.debian.org/reproducible-builds/koji
 
 Package: koji-common
 Architecture: all
 Section: python
 Depends: ${misc:Depends}, ${python:Depends},
-#python-krbV,
+ python-krbv,
  python-openssl,
  python-rpm,
 Description: RPM-based build system - common library
@@ -57,7 +64,6 @@
 Package: koji-client
 Architecture: all
 Depends: python, ${misc:Depends}, ${python:Depends}, koji-common (= ${binary:Version}),
- python-urlgrabber,
  yum,
 Description: RPM-based build system - client
  The Fedora Project uses Koji for their build system, as do several other
@@ -84,13 +90,12 @@
 Depends: python, ${misc:Depends}, ${python:Depends}, koji-common (= ${binary:Version}),
  createrepo,
  python-cheetah,
-#python-krbV,
+ python-krbv,
  python-libvirt,
  python-libxml2,
  python-qpid,
  python-rpm,
  python-simplejson,
- python-urlgrabber,
  yum,
 Recommends: httpd
 Suggests: systemd

## koji 1.16.2

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 NAME=koji
 SPECFILE = $(firstword $(wildcard *.spec))
-SUBDIRS = hub builder koji cli docs util www plugins vm
+SUBDIRS = hub builder koji cli util www plugins vm
 
 ifdef DIST
 DIST_DEFINES := --define "dist $(DIST)"
@@ -59,12 +59,28 @@
 	rm -f *.o *.so *.pyc *~ koji*.bz2 koji*.src.rpm
 	rm -rf koji-$(VERSION)
 	for d in $(SUBDIRS); do make -s -C $$d clean; done
+	coverage erase ||:
 
 git-clean:
 	@git clean -d -q -x
 
-subdirs:
-	for d in $(SUBDIRS); do make -C $$d; [ $$? = 0 ] || exit 1; done
+test:
+	coverage erase
+	PYTHONPATH=hub/.:plugins/hub/.:plugins/builder/.:plugins/cli/.:cli/.:www/lib coverage run \
+	    --source . /usr/bin/nosetests
+	coverage report
+	coverage html
+	@echo Full coverage report in htmlcov/index.html
+
+test3:
+	coverage erase
+	PYTHONPATH=hub/.:plugins/hub/.:plugins/builder/.:plugins/cli/.:cli/. coverage3 run \
+	    --rcfile .coveragerc3 --source . \
+	    /usr/bin/nosetests-3 \
+	    tests/test_lib tests/test_cli
+	coverage report --rcfile .coveragerc3
+	coverage html --rcfile .coveragerc3
+	@echo Full coverage report at file://${PWD}/htmlcov/index.html
 
 test-tarball:
 	@rm -rf .koji-$(VERSION)
@@ -88,6 +104,23 @@
 
 test-rpm: tarball
 	$(RPM_WITH_DIRS) $(DIST_DEFINES) --define "testbuild 1" -bb $(SPECFILE)
+
+pypi:
+	rm -rf dist
+	python setup.py sdist
+	# py2
+	virtualenv build_py2
+	build_py2/bin/pip install --upgrade pip setuptools wheel virtualenv
+	build_py2/bin/python setup.py bdist_wheel
+	rm -rf build_py2
+	# py3
+	python3 -m venv build_py3
+	build_py3/bin/pip install --upgrade pip setuptools wheel virtualenv
+	build_py3/bin/python setup.py bdist_wheel
+	rm -rf build_py3
+
+pypi-upload:
+	twine upload dist/*
 
 tag::
 	git tag -a $(TAG)

=== cli/Makefile ===
--- 
+++ 
@@ -1,3 +1,12 @@
+SUBDIRS=koji_cli
+
+PYTHON=python
+PACKAGE = $(shell basename `pwd`)
+PYVER := $(shell $(PYTHON) -c 'import sys; print("%.3s" %(sys.version))')
+PYSYSDIR := $(shell $(PYTHON) -c 'import sys; print(sys.prefix)')
+PYLIBDIR = $(PYSYSDIR)/lib/python$(PYVER)
+PKGDIR = $(PYLIBDIR)/site-packages
+
 FILES = koji
 
 _default:
@@ -13,7 +22,11 @@
 		exit 1; \
 	fi
 
+	for d in $(SUBDIRS); do make DESTDIR=$(DESTDIR) \
+		-C $$d install; [ $$? = 0 ] || exit 1; done
+
 	mkdir -p $(DESTDIR)/usr/bin
 	install -p -m 755 $(FILES) $(DESTDIR)/usr/bin
+	mkdir -p $(DESTDIR)/etc/koji.conf.d
 	install -p -m 644 koji.conf $(DESTDIR)/etc/koji.conf
-	mkdir -p $(DESTDIR)/etc/koji.conf.d
+	install -p -m 644 koji.conf $(DESTDIR)/etc/koji.conf

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(warning The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
#' <- avoids bad syntax highlighting
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

# nothing to install for docs, we package from this dir
install:
	@echo "(no install for docs dir)"


html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/Koji.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/Koji.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/Koji"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/Koji"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== hub/Makefile ===
--- 
+++ 
@@ -1,9 +1,8 @@
 PYTHON=python
 PACKAGE = $(shell basename `pwd`)
-LIBEXECFILES = rpmdiff
 PYFILES = $(wildcard *.py)
-PYVER := $(shell $(PYTHON) -c 'import sys; print "%.3s" %(sys.version)')
-PYSYSDIR := $(shell $(PYTHON) -c 'import sys; print sys.prefix')
+PYVER := $(shell $(PYTHON) -c 'import sys; print("%.3s" %(sys.version))')
+PYSYSDIR := $(shell $(PYTHON) -c 'import sys; print(sys.prefix)')
 PYLIBDIR = $(PYSYSDIR)/lib/python$(PYVER)
 PKGDIR = $(PYLIBDIR)/site-packages/$(PACKAGE)
 
@@ -24,7 +23,6 @@
 	fi
 
 	mkdir -p $(DESTDIR)/usr/libexec/koji-hub
-	install -p -m 755 $(LIBEXECFILES) $(DESTDIR)/usr/libexec/koji-hub
 
 	mkdir -p $(DESTDIR)/etc/httpd/conf.d
 	install -p -m 644 httpd.conf $(DESTDIR)/etc/httpd/conf.d/kojihub.conf

=== cli/koji_cli/Makefile ===
PYFILES = $(wildcard *.py)

PYTHON=python
PACKAGE = $(shell basename `pwd`)
PYVER := $(shell $(PYTHON) -c 'import sys; print("%.3s" % (sys.version))')
PYSYSDIR := $(shell $(PYTHON) -c 'import sys; print(sys.prefix)')
PYLIBDIR = $(PYSYSDIR)/lib/python$(PYVER)
PKGDIR = $(PYLIBDIR)/site-packages/$(PACKAGE)

_default:
	@echo "nothing to make.  try make install"

clean:
	rm -f *.o *.so *.pyc *~

install:
	@if [ "$(DESTDIR)" = "" ]; then \
		echo " "; \
		echo "ERROR: A destdir is required"; \
		exit 1; \
	fi

	mkdir -p $(DESTDIR)/$(PKGDIR)
	for p in $(PYFILES) ; do \
		install -p -m 644 $$p $(DESTDIR)/$(PKGDIR)/$$p; \
	done

	$(PYTHON) -c "import compileall; compileall.compile_dir('$(DESTDIR)/$(PKGDIR)', 1, '$(PYDIR)', 1)"

=== www/lib/kojiweb/Makefile ===
PYTHON=python
PACKAGE = $(shell basename `pwd`)
PYFILES = $(wildcard *.py)
PYVER := $(shell $(PYTHON) -c 'import sys; print("%.3s" % (sys.version))')
PYSYSDIR := $(shell $(PYTHON) -c 'import sys; print(sys.prefix)')
PYLIBDIR = $(PYSYSDIR)/lib/python$(PYVER)
PKGDIR = $(PYLIBDIR)/site-packages/$(PACKAGE)

SERVERDIR = /kojiweb
FILES = $(wildcard *.py *.chtml)

_default:
	@echo "nothing to make.  try make install"

clean:
	rm -f *.o *.so *.pyc *~
	for d in $(SUBDIRS); do make -s -C $$d clean; done

install:
	@if [ "$(DESTDIR)" = "" ]; then \
		echo " "; \
		echo "ERROR: A destdir is required"; \
		exit 1; \
	fi

	mkdir -p $(DESTDIR)/$(SERVERDIR)
	for p in $(PYFILES) ; do \
		install -p -m 644 $$p $(DESTDIR)/$(SERVERDIR)/$$p; \
	done
	$(PYTHON) -c "import compileall; compileall.compile_dir('$(DESTDIR)/$(SERVERDIR)', 1, '$(PYDIR)', 1)"

=== debian/changelog ===
koji (1.16.2-1) unstable; urgency=medium

  * New upstream version, fixing CVE-2018-1002161. Closes: #922922

 -- Holger Levsen <holger@debian.org>  Sun, 24 Feb 2019 19:44:30 +0100

koji (1.16.1-1) unstable; urgency=medium

  * New upstream version.

 -- Holger Levsen <holger@debian.org>  Thu, 07 Feb 2019 14:22:11 +0100

koji (1.16.0-3) unstable; urgency=medium

  * koji-client: add depends on python-requests and python-dateutil, thanks
    to Juhani Numminen for the bug report. Closes: #918780
  * d/control:
    - bump debhelper compat to 11 so we get nice koji* service handling in
      postinst and postrm.
    - use the new debhelper-compat(=11) notation and drop d/compat.
    - bump standards version to 4.3.0, no changes needed.
    - add "Rules-Requires-Root: no" to support building as non-root.
    - add myself to uploaders.
  * d/copyright:
    - use https for Format: URL.
    - add myself.

 -- Holger Levsen <holger@debian.org>  Wed, 09 Jan 2019 12:11:40 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,14 @@
 Source: koji
 Maintainer: Reproducible Builds Maintainers <reproducible-builds@lists.alioth.debian.org>
 Uploaders: Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>,
- Ximin Luo <infinity0@debian.org>
+ Ximin Luo <infinity0@debian.org>,
+ Holger Levsen <holger@debian.org>
 Section: devel
 Priority: optional
-Standards-Version: 4.1.5
+Standards-Version: 4.3.0
+Rules-Requires-Root: no
 Build-Depends:
- debhelper (>= 9.20160709),
+ debhelper-compat (= 11),
  dh-python,
  createrepo,
  help2man,
@@ -64,6 +66,8 @@
 Package: koji-client
 Architecture: all
 Depends: python, ${misc:Depends}, ${python:Depends}, koji-common (= ${binary:Version}),
+ python-requests,
+ python-dateutil,
  yum,
 Description: RPM-based build system - client
  The Fedora Project uses Koji for their build system, as do several other

=== debian/rules ===
--- 
+++ 
@@ -16,12 +16,20 @@
 	$(H2M) -n "Koji repository administrator" ./util/kojira > debian/kojira.1
 	$(H2M) -n "Koji virtual machine management daemon" ./vm/kojivmd > debian/kojivmd.1
 
+override_dh_auto_test:
+# see Makefile "test" target, we rm coverage stuff because it requires lots of pointless JS
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	PYTHONPATH=hub/.:plugins/hub/.:plugins/builder/.:plugins/cli/.:cli/.:www/lib /usr/bin/nosetests
+endif
+
 override_dh_auto_clean:
 	rm -f debian/koji*.1
 	dh_auto_clean
 
 override_dh_install:
-	dh_install --fail-missing
+	find debian/tmp -name '*.pyc' -delete
+	dh_install
+	dh_missing --fail-missing
 
 override_dh_python2:
 	dh_python2 -p koji-common

=== debian/watch ===
version=3
https://releases.pagure.org/koji/koji-(.+).tar.bz2
